PROGRAM ANSI4Area;

USES Dos,Radu;

type
  FlagType       = array[1..4] of Byte;
  Time           = String[5];
  Date           = String[8];

  MSGTOIDXrecord = String[35];

  COMBINEDrecord = array[1..200] of Word;

  USERSrecord    = record
                     Name           : MSGTOIDXrecord;
                     Location       : String[25];
                     Organisation,
                     Address1,
                     Address2,
                     Address3       : String[50];
                     Handle         : String[35];
                     Comment        : String[80];
                     PasswordCRC    : LongInt;
                     DataPhone,
                     VoicePhone     : String[15];
                     LastTime       : Time;
                     LastDate       : Date;

                     Attribute,

                     Attribute2     : Byte;
                     Flags          : FlagType;
                     Credit,
                     Pending        : LongInt;
                     MsgsPosted,
                     Security       : Word;
                     LastRead,
                     NoCalls,
                     Uploads,
                     Downloads,
                     UploadsK,
                     DownloadsK,
                     TodayK         : LongInt;
                     Elapsed        : Integer;
                     ScreenLength   : Word;
                     LastPwdChange  : Byte;
                     Group          : Word;
                     CombinedInfo   : COMBINEDrecord;
                     FirstDate,
                     BirthDate,
                     SubDate        : Date;
                     ScreenWidth,
                     Language,
                     DateFormat     : Byte;
                     ForwardTo      : String[35];
                     MsgArea,
                     FileArea       : Word;
                     DefaultProtocol: Char;
                     FileGroup      : Word;
                     LastDOBCheck   : Byte;
                     Sex            : Byte;
                     XIrecord       : LongInt;
                     MsgGroup       : Word;

                     Attribute3     : Byte;


                     Password       : String[15];

                     FreeSpace      : Array[1..31] of Byte;
                   end;

  USERSXIrecord  = record
                     FreeSpace      : Array[1..200] of Byte;
                   end;

  SYSINFOrecord  = record
                     TotalCalls     : LongInt;
                     LastCaller,
                     LastHandle     : MSGTOIDXrecord;
                     ExtraSpace     : array[1..92] of Byte;
                   end;

  TIMELOGrecord  = record
                     StartDate      : Date;
                     BusyPerHour    : array[0..23] of Word;
                     BusyPerDay     : array[0..6] of Word;
                   end;

  EVENTrecord    = record
                     Status         : Byte; { 0=Deleted 1=Enabled 2=Disabled }
                     StartTime      : Time;
                     ErrorLevel     : Byte;
                     Days           : Byte;
                     Forced         : Boolean;
                     LastTimeRun    : Date;
                  end;

  EXITINFOrecord = record
                     Baud             : Word;
                     SysInfo          : SYSINFOrecord;
                     TimeLogInfo      : TIMELOGrecord;
                     UserInfo         : USERSrecord;
                     EventInfo        : EVENTrecord;
                     NetMailEntered,
                     EchoMailEntered  : Boolean;
                     LoginTime        : Time;
                     LoginDate        : Date;
                     TimeLimit        : Word;
                     LoginSec         : LongInt;
                     UserRecord       : Integer;
                     ReadThru,
                     NumberPages,
                     DownloadLimit    : Word;
                     TimeOfCreation   : Time;
                     LogonPasswordCRC : LongInt;
                     WantChat         : Boolean;

                     DeductedTime     : Integer;
                     MenuStack        : Array[1..50] of String[8];
                     MenuStackPointer : Byte;
                     UserXIinfo       : USERSXIrecord;
                     ErrorFreeConnect,
                     SysopNext        : Boolean;

                     EMSI_Session     : Boolean;        { These fields hold  }
                     EMSI_Crtdef,                       { data related to an }
                     EMSI_Protocols,                    { EMSI session       }
                     EMSI_Capabilities,
                     EMSI_Requests,
                     EMSI_Software    : String[40];
                     Hold_Attr1,
                     Hold_Attr2,
                     Hold_Len         : Byte;

                     PageReason       : String[80];
                     StatusLine       : Byte;
                     LastCostMenu     : String[8];
                     MenuCostPerMin   : Word;

                     DoesAVT,
                     RIPmode          : Boolean;
                     RIPVersion       : Byte;
                     ExtraSpace       : Array[1..85] of Byte;
                     end;

PROCEDURE fancywipeout;

VAR b,c,d:byte;

   BEGIN
   randomize;
   c:=random(6);
   if c=0 then
      BEGIN
      gotoxy(1,1);
      for b:=1 to 23 do
         BEGIN
         insline;
         delay(30);
         END;
      END;
   if c=1 then
      BEGIN
      for b:=23 downto 1 do
          BEGIN
          gotoxy(1,b);
          clreol;
          delay(30);
          END;
      END;
    if c=2 then
      BEGIN
      for b:=1 to 23 do
          BEGIN
          gotoxy(1,b);
          clreol;
          delay(30);
          END;
      END;
   if c=3 then
      BEGIN
      for b:=1 to 23 do
          BEGIN
          if b mod 2 = 0 then
             BEGIN
             gotoxy(1,(12+(b div 2)));
             clreol;
             END
            else
             BEGIN
             gotoxy(1,(12-(b div 2)));
             clreol;
             END;
          delay(28);
          END;
      END;
   if c=4 then
      BEGIN
      for b:=23 downto 1 do
          BEGIN
          gotoxy(1,b);
          insline;
          delay(28);
          END;
      for b:=1 to 23 do
          BEGIN
          gotoxy(1,1);
          insline;
          END;
      END;
   if c=5 then
      BEGIN
      for b:=23 downto 1 do
          BEGIN
          if b mod 2 = 0 then
             BEGIN
             gotoxy(1,(12+(b div 2)));
             clreol;
             END
            else
             BEGIN
             gotoxy(1,(12-(b div 2)));
             clreol;
             END;
          delay(28);
          END;
      END;
   END;

VAR userfile:file of exitinforecord;
    user:exitinforecord;
    promptf:text;
    prompt:array[1..80] of string;
    areast:string;
    lengthp:byte;
    yposp:byte;
    xposp:byte;
    delayp:byte;
    a:byte;

PROCEDURE beep;
 var boop:byte;

BEGIN
for boop:=1 to 3 do
    BEGIN
    sound(1500);
    delay(300);
    nosound;
    delay(100);
    END;
END;

PROCEDURE stdprompt;
      BEGIN
      prompt[1]:='[0;1;30mP';
      prompt[2]:='[0mP';
      prompt[3]:='[1mP';
      prompt[4]:='P[30mR';
      prompt[5]:='[0mPR';
      prompt[6]:='[1;30mP[37mR';
      prompt[7]:='[0;30m-[1;37mR[30mE';
      prompt[8]:=' [0mRE';
      prompt[9]:=' [1;30mR[37mE';
      prompt[10]:=' [0;30m-[1;37mE[30mS';
      prompt[11]:='  [0mES';
      prompt[12]:='  [1;30mE[37mS';
      prompt[13]:='  [0;30m-[1;37mS[30mS';
      prompt[14]:='   [0mSS';
      prompt[15]:='   [1;30mS[37mS';
      prompt[16]:='   [0;30m-[1;37mS';
      prompt[17]:='    [0mS';
      prompt[18]:='    [1;30mS';
      prompt[19]:='    [0;30m--';
      prompt[20]:='[5C-';
      prompt[21]:='[5C-';
      prompt[22]:='[5C-[1mE';
      prompt[23]:='[5C[0;30m-[37mE';
      prompt[24]:='[6C[1mE';
      prompt[25]:='[6CE[30mN';
      prompt[26]:='[6C[0mEN';
      prompt[27]:='[6C[1;30mE[37mN';
      prompt[28]:='[6C[0;30m-[1;37mN[30mT';
      prompt[29]:='[7C[0mNT';
      prompt[30]:='[7C[1;30mN[37mT';
      prompt[31]:='[7C[0;30m-[1;37mT[30mE';
      prompt[32]:='[8C[0mTE';
      prompt[33]:='[8C[1;30mT[37mE';
      prompt[34]:='[7C[0;30m--[1;37mE[30mR';
      prompt[35]:='[9C[0mER';
      prompt[36]:='[9C[1;30mE[37mR';
      prompt[37]:='[9C[0;30m-[1;37mR';
      prompt[38]:='[10C[0mR';
      prompt[39]:='[10C[1;30mR';
      prompt[40]:='[8C[0;30m- -';
      lengthp:=40;
      xposp:=33;
      yposp:=23;
      delayp:=90;
      END;

BEGIN
if (paramstr(1)='/v') or (paramstr(1)='/V') then
   BEGIN
   writeln('? ANSi4AREA by POTi^XPRESS (iNTERNAL VERSiONNUMBER: 7)');
   exit;
   END;
{***** INITIALISIERUNG}
rc:='1231231143124423';
dorinit;
unonset:='user ist watching an ansi';
{***** READ EXITINFO}
assign (userfile,'exitinfo.bbs');
{$I-}
reset (userfile);
{$I+}
if ioresult<>0 then
   BEGIN
   writeln('# Error loading exitinfo.bbs');
   beep;
   exit;
   END;
read (userfile,user);
close (userfile);
str(user.userinfo.filearea,areast);
{****** CHECK EXISTANCE OF ANSI}
if fsearch('area'+areast+'.ans',dorpath+'ansi\') = '' then
   BEGIN
{****** NO ANSI WAS FOUND}
   END
  else
   BEGIN
{****** DISPLAYANSI}
   dordisplay(dorpath+'ansi\'+'\area'+areast+'.ans','',false);
{****** READ ANIMPROMPT}
   assign(promptf,dorpath+'ansi\'+'\area'+areast+'.ptm');
   {$I-}
   reset(promptf);
   {$I+}
   if ioresult<>0 then
      BEGIN
      stdprompt;
      END
    else
      BEGIN
      readln(promptf,lengthp);
      readln(promptf,xposp);
      readln(promptf,yposp);
      readln(promptf,delayp);
      if (ioresult<>0) or (lengthp>80) then
         BEGIN
         beep;
         stdprompt;
         END
       else
         BEGIN
         a:=0;
         for a:=1 to lengthp do
            BEGIN
            readln(promptf,prompt[a]);
            END;
         close(promptf);
         END;
      END;
{****** OUTPUT ANIMPROMPT}
   a:=0;
   repeat
   a:=a+1;
   gotoxy(xposp,yposp);
   write (prompt[a]);
   delay(delayp);
   if a=lengthp then a:=0;
   until keypressed;
{****** ENTE}
   fancywipeout;
   END;
END.

